using LiteDB;
using skydiveLogs_api.Domain;
using skydiveLogs_api.DomainService.Repositories;
using skydiveLogs_api.Infrastructure.Interfaces;
using System.Collections.Generic;

namespace skydiveLogs_api.Infrastructure
{
    public class StatsByYearByJumpTypeRepository : IStatsByYearByJumpTypeRepository
    {
        #region Public Constructors

        public StatsByYearByJumpTypeRepository(IDataProvider dataProvider)
        {
            _dataProvider = dataProvider;
            _col = _dataProvider.CollOfStatsByYearByJumpType;
        }

        #endregion Public Constructors

        #region Public Methods

        public int Add(IEnumerable<StatsByYearByJumpType> newStats)
        {
            int result = 0;

            try
            {
                foreach (var newStat in newStats)
                {
                    var tmp = _col.Insert(newStats);
                    result = tmp;
                }
            }
            catch
            {
                result = 0;
            }

            return result;
        }

        public IEnumerable<StatsByYearByJumpType> GetAll(User user)
        {
            return _col.Include(x => x.User)
                       .Query()
                       .Where(j => j.User.Id == user.Id)
                       .ToList();
        }

        public bool Update(IEnumerable<StatsByYearByJumpType> updatedStats, User user)
        {
            Delete(user);
            var tmp = Add(updatedStats);

            return tmp != 0;
        }

        public bool Delete(User user)
        {
            var tmp = _col.DeleteMany(s => s.User.Id == user.Id);
            return tmp != 0;
        }

        #endregion Public Methods

        #region Private Fields

        private readonly ILiteCollection<StatsByYearByJumpType> _col;
        private readonly IDataProvider _dataProvider;

        #endregion Private Fields
    }
}